<template>
  <div class="animation_dialog">
    <el-dialog
      v-model="showLoginDialog"
      :before-close="toggleLoginRegisterDialog"
      destroy-on-close
      width="100%"
      custom-class="animation-dialog login-dialog"
    >
      <template #title>
        <div class="flex-auto font-medium fc-text3 pl-2">
          <span class="text-base font-medium fc-text3 login-text-color">
            {{ $t("capital_login") }}
          </span>
        </div>
      </template>
      <div class="mx-auto px-2 py-4 h-[calc(100vh-57px)] overflow-scroll">
        <el-form
          ref="loginFormRef"
          label-position="top"
          :model="loginFormData"
          :rules="loginRules"
          :validate-on-rule-change="false"
          class="w-full mx-auto"
          :class="isMain ? 'main-form' : ''"
        >
          <el-form-item :label="$t('username')" prop="Username">
            <el-input
              v-model="loginFormData.Username"
              :placeholder="$t('username')"
              type="text"
            />
          </el-form-item>
          <el-form-item
            v-if="theme != 'bk8' && !isMain"
            :label="$t('password')"
            prop="Password"
          >
            <el-input
              v-model="loginFormData.Password"
              show-password
              :placeholder="$t('password')"
              type="password"
            />
          </el-form-item>
          <el-form-item
            v-if="theme == 'bk8' || isMain"
            :label="$t('password')"
            prop="Password"
            show-password
          >
            <el-input
              v-model="loginFormData.Password"
              :placeholder="$t('password')"
              :type="inputTypePw"
              class="bk8"
            >
              <template #suffix>
                <div
                  :class="isMain ? 'flex items-center' : ''"
                  @click.prevent="showPassword()"
                >
                  <font-awesome-icon
                    v-if="isShowPassword"
                    icon="eye-slash"
                    class="fc-text"
                  />
                  <font-awesome-icon v-else icon="eye" class="fc-text" />
                </div>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item class="forgot-password-form-item">
            <auth-forgot-password-modal :fullscreen="true" />
          </el-form-item>
          <el-form-item v-if="!clientCaptcha.IsHidden" prop="Captcha">
            <div class="captcha">
              <captcha
                :value="loginFormData.Captcha"
                @is-valid="getCaptchaErrorMsg"
              />
              <el-input
                v-model="loginFormData.Captcha"
                type="text"
                :placeholder="$t('enter_validation_code')"
              />
            </div>
          </el-form-item>
          <div class="flex justify-center">
            <el-button
              :loading="isLoginProccessing"
              :type="{ danger: theme !== 'bk8' }"
              round
              @click="submitLogin(loginFormRef)"
              >{{ $t("submit") }}</el-button
            >
          </div>
        </el-form>
        <p
          v-if="!register.IsHidden"
          class="mt-4 text-center text-sm leading-4 font-normal fc-text2"
        >
          {{ $t("you_do_not_have_account_yet") }} ?
          <span
            :id="ID.SIGNUP"
            class="join-now-entry-link"
            @click="toggleLoginRegisterDialog(false)"
            >{{ $t("joinnow") }}
          </span>
        </p>
      </div>
      <theme-common-telegram-login-button
        :is-show="isTelegramBotSetup"
        :username="telegramBotUsername"
        @callback="telegramCallbackFunction"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import useLogin from "@/composables/useLogin";
import { store } from "@/store";

export default defineComponent({
  name: "Login",
  setup() {
    const { toggleLoginRegisterDialog } = commonHelper;
    const showLoginDialog = computed(() => store.state.showLoginDialog);
    const isMain = computed(
      () =>
        store.state.selectedThemeName === "main" &&
        !store.state.companyThemePropertiesFromApi.ThemeProperties[0].ThemeName.toLowerCase().includes(
          "bk8"
        )
    );
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      register,
      clientCaptcha,
      getCaptchaErrorMsg,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
    } = useLogin();
    const { themeColor } = themePropertyHelper;
    const theme = themeColor.value.Text;
    const inputTypePw = ref("password");
    const isShowPassword = ref(false);
    const showPassword = () => {
      if (inputTypePw.value === "text") {
        inputTypePw.value = "password";
        isShowPassword.value = false;
      } else if (inputTypePw.value === "password") {
        inputTypePw.value = "text";
        isShowPassword.value = true;
      }
    };
    const themeName = store.state.selectedThemeName;
    return {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      showLoginDialog,
      register,
      theme,
      clientCaptcha,
      getCaptchaErrorMsg,
      showPassword,
      inputTypePw,
      isShowPassword,
      toggleLoginRegisterDialog,
      themeName,
      isMain,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
    };
  },
});
</script>
<style scoped lang="scss">
:deep(.el-dialog__headerbtn .el-dialog__close) {
  color: var(--text5);
}
:deep(.el-dialog__header) {
  margin: 0;
  padding: 0;
  height: 52px;
  position: relative;
  display: flex;
  justify-content: space-between;
  align-items: center;
  background: var(--background3);

  &:after {
    content: "";
    position: absolute;
    bottom: 0;
    width: 100%;
    height: 1px;
    background: var(--background4);
  }

  .el-dialog__headerbtn {
    position: unset;
    width: 24px;
    height: 24px;
    padding-right: 16px;
    display: flex;
    justify-content: center;
    align-items: center;
  }
}
:deep(.el-dialog__body) {
  background: var(--background2);
}
.text-primary {
  color: var(--primary);
}
:deep(button.el-button) {
  width: 152px;
  height: 40px;
  background-color: var(--primary);
  border: none;
  border-radius: 20px;
}

:deep(.el-input__inner) {
  height: 48px;
  border-radius: 8px;
  background: var(--background1);

  &:-webkit-autofill {
    -webkit-background-clip: text;
    -webkit-text-fill-color: var(--text);
  }
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4 text-[color:var(--textBtn)];
}
</style>
<style lang="scss">
[theme-color="global_light_01"] {
  .login-text-color,
  .el-dialog__headerbtn .el-dialog__close {
    color: var(--text3);
  }
}
.animation-dialog {
  .el-dialog__headerbtn {
    top: 3px;
    .el-icon {
      width: auto;
      height: auto;
      svg {
        width: 20px;
        height: 20px;
      }
    }
  }
}
[theme-color="bk8"] .bk8 {
  .el-input__suffix {
    align-items: center;
    .svg-inline--fa {
      color: var(--text);
    }
  }
}
.main-form .el-form-item:first-child {
  margin-bottom: 8px;
}
.main-form .el-form-item__label {
  --el-text-color-regular: var(--text2);
}
</style>
